#pragma once

#include "iDataProcessor.hpp"
#include "HistoData.hpp"
#include <exception>

class DataProcessorFactoryException: public std::exception
{
	public:
		DataProcessorFactoryException(const char *msg, int code);
		~DataProcessorFactoryException() throw ();
		const char *what() const throw();
		int code() const;
	private:
		std::string msg_;
		int code_;
};

class DataProcessorFactory
{
	public:
		static iDataProcessor *create(const sc_tdc_format &, HistoData &);
	private:
		DataProcessorFactory() {};
};
