#pragma once

#include <QMainWindow>
#include <QWidget>
#include <QSpinBox>
#include <QDoubleSpinBox>
#include <QPushButton>
#include <QTextEdit>
#include <QHBoxLayout>
#include <QFormLayout>
#include <QCheckBox>
#include <QLabel>
#include <QCloseEvent>
#include <QComboBox>
#include "Mhisto.h"
#include "Mrates.h"

class Mwidget: public QWidget
{
		Q_OBJECT
	public:
		Mwidget(QWidget *parent = 0);
		static void callback(void *, int a);
	public slots:
		void save_data();
		void init_deinit(bool);
	private:
		void init_objects(void);
		void init_connections(void);
		void init_layout(void);
		void event_reaction_signalizer(int);
		QSpinBox *spinbox_buffersize;
		QSpinBox *spinbox_mestime;
		QSpinBox *spinbox_iterations_todo;
		QSpinBox *spinbox_iters_left;
		QSpinBox *spinbox_event_threshold;
		QSpinBox *spinbox_histosize;
		QDoubleSpinBox *spinbox_binsize;
		QPushButton *button_bufalloc;
		QPushButton *button_start;
		QLabel *label_autorun;
		QLabel *label_buffer_size;
		QLabel *label_mes_time;
		QLabel *label_accumulate;
		QLabel *label_iterations_todo;
		QLabel *label_iters_left;
		QLabel *label_event_threshold;
		QLabel *label_binsize;
		QLabel *label_histosize;
		Mhisto *histo;
		Mrates *rates;
		QHBoxLayout *layout;
		QFormLayout *flayout;
		QCheckBox *autorun;
		QCheckBox *checkbox_accumulate;
		unsigned *buffer;
		bool running;
		enum {
			IDLE,
			STOPPING,
			RUNNING
		} state;
	private slots:
		void buffer_alloc(void);
		void event_reaction(int);
		void start_stop(void);
		void do_error_check(int);
		void histosize_changed(int);
	signals:
		void do_event_reaction(int);
		void takeBuffer(
			unsigned int *,
			int,
			int,
			long long
		);
		void show_this(QString);
	private:
		long long histosize;
};

