#pragma once

#include "HistoData.hpp"
#include <scTDC_types.h>

class iDataProcessor
{
	public:
		iDataProcessor(HistoData &h);
		/*
		 * process() function should process data in the buffer
		 * accordingly to the format which is got from sc_tdc_get_format().
		 * All processing data must be stored in histo_data_; maxX_ and minX_
		 * must be set; maximum Y value should be returned.
		 */
		virtual int process(void *, int) = 0;
		int maxX() const;
		int minX() const;
		void resetX();
	protected:
		HistoData &histo_data_;
		int maxX_;
		int minX_;

};
